## org.jfree.chart.renderer
Class AbstractRenderer

    java.lang.Object
      org.jfree.chart.renderer.AbstractRenderer

All Implemented Interfaces:
  java.lang.Cloneable, java.io.Serializable

Direct Known Subclasses:
  AbstractCategoryItemRenderer, AbstractXYItemRenderer, DefaultPolarItemRenderer, WaferMapRenderer

public abstract class AbstractRenderer
extends java.lang.Object
implements java.lang.Cloneable, java.io.Serializable

Base class providing common services for renderers. Most methods that update attributes of the renderer will fire a `RendererChangeEvent`, which normally means the plot that owns the renderer will receive notification that the renderer has been changed (the plot will, in turn, notify the chart).

See Also:
  Serialized Form

Field Summary
`static java.awt.Paint` `DEFAULT_OUTLINE_PAINT` The default outline paint.
`static java.awt.Stroke` `DEFAULT_OUTLINE_STROKE` The default outline stroke.
`static java.awt.Paint` `DEFAULT_PAINT` The default paint.
`static java.awt.Shape` `DEFAULT_SHAPE` The default shape.
`static java.awt.Stroke` `DEFAULT_STROKE` The default stroke.
`static java.awt.Font` `DEFAULT_VALUE_LABEL_FONT` The default value label font.
`static java.awt.Paint` `DEFAULT_VALUE_LABEL_PAINT` The default value label paint.
`static java.lang.Double` `ZERO` A useful constant.

Constructor Summary
`AbstractRenderer()` Default constructor.

Method Summary
`void` `addChangeListener(RendererChangeListener listener)` Registers an object to receive notification of changes to the renderer.
`protected java.awt.geom.Point2D` `calculateLabelAnchorPoint(ItemLabelAnchor anchor, double x, double y, PlotOrientation orientation)` Calculates the item label anchor point.
`protected java.lang.Object` `clone()` Returns an independent copy of the renderer.
`protected java.awt.Shape` `createTransformedShape(java.awt.Shape shape, double translateX, double translateY)` Creates and returns a translated version of a shape.
`boolean` `equals(java.lang.Object obj)` Tests this renderer for equality with another object.
`ItemLabelAnchor` `getBaseItemLabelAnchor()` Deprecated. Use getBasePositiveItemLabelPosition()/getBaseNegativeItemLabelPosition().
`java.lang.Number` `getBaseItemLabelAngle()` Deprecated. Use getBasePositiveItemLabelPosition()/getBaseNegativeItemLabelPosition().
`java.awt.Font` `getBaseItemLabelFont()` Returns the base item label font (this is used when no other font setting is available).
`java.awt.Paint` `getBaseItemLabelPaint()` Returns the base item label paint.
`org.jfree.ui.TextAnchor` `getBaseItemLabelRotationAnchor()` Deprecated. Use getBasePositiveItemLabelPosition()/getBaseNegativeItemLabelPosition().
`java.lang.Boolean` `getBaseItemLabelsVisible()` Returns the base setting for item label visibility.
`org.jfree.ui.TextAnchor` `getBaseItemLabelTextAnchor()` Deprecated. Use getBasePositiveItemLabelPosition()/getBaseNegativeItemLabelPosition().
`ItemLabelPosition` `getBaseNegativeItemLabelPosition()` Returns the base item label position for negative values.
`java.awt.Paint` `getBaseOutlinePaint()` Returns the base outline paint.
`java.awt.Stroke` `getBaseOutlineStroke()` Returns the base outline stroke.
`java.awt.Paint` `getBasePaint()` Returns the base paint.
`ItemLabelPosition` `getBasePositiveItemLabelPosition()` Returns the base positive item label position.
`java.awt.Shape` `getBaseShape()` Returns the base shape.
`java.awt.Stroke` `getBaseStroke()` Returns the base stroke.
`abstract DrawingSupplier` `getDrawingSupplier()` Returns the drawing supplier from the plot.
`ItemLabelAnchor` `getItemLabelAnchor(int row, int column)` Deprecated. Use getPositiveItemLabelPosition() or getNegativeItemLabelPosition().
`double` `getItemLabelAnchorOffset()` Returns the item label anchor offset.
`java.lang.Number` `getItemLabelAngle(int row, int column)` Deprecated. Use getPositiveItemLabelPosition()/getNegativeItemLabelPosition().
`java.awt.Font` `getItemLabelFont()` Returns the font used for all item labels.
`java.awt.Font` `getItemLabelFont(int row, int column)` Returns the font for an item label.
`java.awt.Paint` `getItemLabelPaint()` Returns the paint used for all item labels.
`java.awt.Paint` `getItemLabelPaint(int row, int column)` Returns the paint used to draw an item label.
`org.jfree.ui.TextAnchor` `getItemLabelRotationAnchor(int row, int column)` Deprecated. Use getPositiveItemLabelPosition()/getNegativeItemLabelPosition().
`org.jfree.ui.TextAnchor` `getItemLabelTextAnchor(int row, int column)` Deprecated. Use getPositiveItemLabelPosition()/getNegativeItemLabelPosition().
`java.awt.Paint` `getItemOutlinePaint(int row, int column)` Returns the paint used to outline data items as they are drawn.
`java.awt.Stroke` `getItemOutlineStroke(int row, int column)` Returns the stroke used to outline data items.
`java.awt.Paint` `getItemPaint(int row, int column)` Returns the paint used to fill data items as they are drawn.
`java.awt.Shape` `getItemShape(int row, int column)` Returns a shape used to represent a data item.
`java.awt.Stroke` `getItemStroke(int row, int column)` Returns the stroke used to draw data items.
`ItemLabelPosition` `getNegativeItemLabelPosition()` Returns the item label position for negative values in ALL series.
`ItemLabelPosition` `getNegativeItemLabelPosition(int row, int column)` Returns the item label position for negative values.
`ItemLabelPosition` `getPositiveItemLabelPosition()` Returns the item label position for positive values in ALL series.
`ItemLabelPosition` `getPositiveItemLabelPosition(int row, int column)` Returns the item label position for positive values.
`ItemLabelAnchor` `getSeriesItemLabelAnchor(int series)` Deprecated. Use getSeriesPositiveItemLabelPosition() or getSeriesNegativeItemLabelPosition().
`java.lang.Number` `getSeriesItemLabelAngle(int series)` Deprecated. Use getSeriesPositiveItemLabelPosition()/getSeriesNegativeItemLabelPosition().
`java.awt.Font` `getSeriesItemLabelFont(int series)` Returns the font for all the item labels in a series.
`java.awt.Paint` `getSeriesItemLabelPaint(int series)` Returns the paint used to draw the item labels for a series.
`org.jfree.ui.TextAnchor` `getSeriesItemLabelRotationAnchor(int series)` Deprecated. Use getSeriesPositiveItemLabelPosition()/getSeriesNegativeItemLabelPosition().
`org.jfree.ui.TextAnchor` `getSeriesItemLabelTextAnchor(int series)` Deprecated. Use getSeriesPositiveItemLabelPosition()/getSeriesNegativeItemLabelPosition().
`ItemLabelPosition` `getSeriesNegativeItemLabelPosition(int series)` Returns the item label position for all negative values in a series.
`java.awt.Paint` `getSeriesOutlinePaint(int series)` Returns the paint used to outline an item drawn by the renderer.
`java.awt.Stroke` `getSeriesOutlineStroke(int series)` Returns the stroke used to outline the items in a series.
`java.awt.Paint` `getSeriesPaint(int series)` Returns the paint used to fill an item drawn by the renderer.
`ItemLabelPosition` `getSeriesPositiveItemLabelPosition(int series)` Returns the item label position for all positive values in a series.
`java.awt.Shape` `getSeriesShape(int series)` Returns a shape used to represent the items in a series.
`java.awt.Stroke` `getSeriesStroke(int series)` Returns the stroke used to draw the items in a series.
`int` `hashCode()` Returns a hashcode for the renderer.
`boolean` `isItemLabelVisible(int row, int column)` Returns `true` if an item label is visible, and `false` otherwise.
`boolean` `isSeriesItemLabelsVisible(int series)` Returns `true` if the item labels for a series are visible, and `false` otherwise.
`void` `notifyListeners(RendererChangeEvent event)` Notifies all registered listeners that the renderer has been modified.
`void` `removeChangeListener(RendererChangeListener listener)` Deregisters an object so that it no longer receives notification of changes to the renderer.
`void` `setBaseAngle(java.lang.Number angle)` Deprecated. Use setBasePositiveItemLabelPosition()/setBaseNegativeItemLabelPosition().
`void` `setBaseItemLabelAnchor(ItemLabelAnchor anchor)` Deprecated. Use setBasePositiveItemLabelPosition()/setBaseNegativeItemLabelPosition().
`void` `setBaseItemLabelFont(java.awt.Font font)` Sets the base item label font and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseItemLabelFont(java.awt.Font font, boolean notify)` Sets the base item label font and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseItemLabelPaint(java.awt.Paint paint)` Sets the base item label paint and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseItemLabelPaint(java.awt.Paint paint, boolean notify)` Sets the base item label paint and, if requested, sends a `RendererChangeEvent` to all registered listeners..
`void` `setBaseItemLabelRotationAnchor(org.jfree.ui.TextAnchor anchor)` Deprecated. Use setBasePositiveItemLabelPosition()/setBaseNegativeItemLabelPosition().
`void` `setBaseItemLabelsVisible(boolean visible)` Sets the base flag that controls whether or not item labels are visible.
`void` `setBaseItemLabelsVisible(java.lang.Boolean visible)` Sets the base setting for item label visibility.
`void` `setBaseItemLabelsVisible(java.lang.Boolean visible, boolean notify)` Sets the base visibility for item labels and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseItemLabelTextAnchor(org.jfree.ui.TextAnchor anchor)` Deprecated. Use setBasePositiveItemLabelPosition()/setBaseNegativeItemLabelPosition().
`void` `setBaseNegativeItemLabelPosition(ItemLabelPosition position)` Sets the base item label position for negative values and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseNegativeItemLabelPosition(ItemLabelPosition position, boolean notify)` Sets the base negative item label position and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseOutlinePaint(java.awt.Paint paint)` Sets the base outline paint and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseOutlinePaint(java.awt.Paint paint, boolean notify)` Sets the base outline paint and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseOutlineStroke(java.awt.Stroke stroke)` Sets the base outline stroke and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseOutlineStroke(java.awt.Stroke stroke, boolean notify)` Sets the base outline stroke and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBasePaint(java.awt.Paint paint)` Sets the base paint and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBasePaint(java.awt.Paint paint, boolean notify)` Sets the base paint and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBasePositiveItemLabelPosition(ItemLabelPosition position)` Sets the base positive item label position.
`void` `setBasePositiveItemLabelPosition(ItemLabelPosition position, boolean notify)` Sets the base positive item label position and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseShape(java.awt.Shape shape)` Sets the base shape and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseShape(java.awt.Shape shape, boolean notify)` Sets the base shape and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseStroke(java.awt.Stroke stroke)` Sets the base stroke.
`void` `setBaseStroke(java.awt.Stroke stroke, boolean notify)` Sets the base stroke and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setItemLabelAnchor(ItemLabelAnchor anchor)` Deprecated. Use setPositiveItemLabelPosition()/setNegativeItemLabelPosition().
`void` `setItemLabelAnchorOffset(double offset)` Sets the item label anchor offset.
`void` `setItemLabelAngle(java.lang.Number angle)` Deprecated. Use setPositiveItemLabelPosition()/setNegativeItemLabelPosition().
`void` `setItemLabelFont(java.awt.Font font)` Sets the item label font for ALL series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setItemLabelFont(java.awt.Font font, boolean notify)` Sets the item label font for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setItemLabelPaint(java.awt.Paint paint)` Sets the item label paint for ALL series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setItemLabelPaint(java.awt.Paint paint, boolean notify)` Sets the item label paint for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setItemLabelRotationAnchor(org.jfree.ui.TextAnchor anchor)` Deprecated. Use setPositiveItemLabelPosition()/setNegativeItemLabelPosition().
`void` `setItemLabelsVisible(boolean visible)` Sets the visibility of the item labels for ALL series.
`void` `setItemLabelsVisible(java.lang.Boolean visible)` Sets the visibility of the item labels for ALL series (optional).
`void` `setItemLabelsVisible(java.lang.Boolean visible, boolean notify)` Sets the visibility of item labels for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setItemLabelTextAnchor(org.jfree.ui.TextAnchor anchor)` Deprecated. Use setPositiveItemLabelPosition()/setNegativeItemLabelPosition().
`void` `setNegativeItemLabelPosition(ItemLabelPosition position)` Sets the item label position for negative values in ALL series, and sends a `RendererChangeEvent` to all registered listeners.
`void` `setNegativeItemLabelPosition(ItemLabelPosition position, boolean notify)` Sets the item label position for negative values in ALL series and (if requested) sends a `RendererChangeEvent` to all registered listeners.
`void` `setOutlinePaint(java.awt.Paint paint)` Sets the outline paint for ALL series (optional).
`void` `setOutlinePaint(java.awt.Paint paint, boolean notify)` Sets the outline paint for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setOutlineStroke(java.awt.Stroke stroke)` Sets the outline stroke for ALL series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setOutlineStroke(java.awt.Stroke stroke, boolean notify)` Sets the outline stroke for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setPaint(java.awt.Paint paint)` Sets the paint to be used for ALL series, and sends a `RendererChangeEvent` to all registered listeners.
`void` `setPaint(java.awt.Paint paint, boolean notify)` Sets the paint to be used for all series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setPositiveItemLabelPosition(ItemLabelPosition position)` Sets the item label position for positive values in ALL series, and sends a `RendererChangeEvent` to all registered listeners.
`void` `setPositiveItemLabelPosition(ItemLabelPosition position, boolean notify)` Sets the positive item label position for ALL series and (if requested) sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesAngle(int series, java.lang.Number angle)` Deprecated. Use setSeriesPositiveItemLabelPosition()/setSeriesNegativeItemLabelPosition().
`void` `setSeriesItemLabelAnchor(int series, ItemLabelAnchor anchor)` Deprecated. Use setSeriesPositiveItemLabelPosition()/setSeriesNegativeItemLabelPosition().
`void` `setSeriesItemLabelFont(int series, java.awt.Font font)` Sets the item label font for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelFont(int series, java.awt.Font font, boolean notify)` Sets the item label font for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelPaint(int series, java.awt.Paint paint)` Sets the item label paint for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelPaint(int series, java.awt.Paint paint, boolean notify)` Sets the item label paint for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelRotationAnchor(int series, org.jfree.ui.TextAnchor anchor)` Deprecated. Use setSeriesPositiveItemLabelPosition()/setSeriesNegativeItemLabelPosition().
`void` `setSeriesItemLabelsVisible(int series, boolean visible)` Sets a flag that controls the visibility of the item labels for a series.
`void` `setSeriesItemLabelsVisible(int series, java.lang.Boolean visible)` Sets the visibility of the item labels for a series.
`void` `setSeriesItemLabelsVisible(int series, java.lang.Boolean visible, boolean notify)` Sets the visibility of item labels for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelTextAnchor(int series, org.jfree.ui.TextAnchor anchor)` Deprecated. Use setSeriesPositiveItemLabelPosition()/setSeriesNegativeItemLabelPosition().
`void` `setSeriesNegativeItemLabelPosition(int series, ItemLabelPosition position)` Sets the item label position for negative values in a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesNegativeItemLabelPosition(int series, ItemLabelPosition position, boolean notify)` Sets the item label position for negative values in a series and (if requested) sends a.
`void` `setSeriesOutlinePaint(int series, java.awt.Paint paint)` Sets the paint used for a series outline and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesOutlinePaint(int series, java.awt.Paint paint, boolean notify)` Sets the paint used to draw the outline for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesOutlineStroke(int series, java.awt.Stroke stroke)` Sets the outline stroke used for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesOutlineStroke(int series, java.awt.Stroke stroke, boolean notify)` Sets the outline stroke for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesPaint(int series, java.awt.Paint paint)` Sets the paint used for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesPaint(int series, java.awt.Paint paint, boolean notify)` Sets the paint used for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesPositiveItemLabelPosition(int series, ItemLabelPosition position)` Sets the item label position for all positive values in a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesPositiveItemLabelPosition(int series, ItemLabelPosition position, boolean notify)` Sets the item label position for all positive values in a series and (if requested) sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesShape(int series, java.awt.Shape shape)` Sets the shape used for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesShape(int series, java.awt.Shape shape, boolean notify)` Sets the shape for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesStroke(int series, java.awt.Stroke stroke)` Sets the stroke used for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesStroke(int series, java.awt.Stroke stroke, boolean notify)` Sets the stroke for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setShape(java.awt.Shape shape)` Sets the shape for ALL series (optional) and sends a `RendererChangeEvent` to all registered listeners.
`void` `setShape(java.awt.Shape shape, boolean notify)` Sets the shape for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setStroke(java.awt.Stroke stroke)` Sets the stroke for ALL series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setStroke(java.awt.Stroke stroke, boolean notify)` Sets the stroke for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ZERO

    public static final java.lang.Double ZERO

  A useful constant.

### DEFAULT_PAINT

    public static final java.awt.Paint DEFAULT_PAINT

  The default paint.

### DEFAULT_OUTLINE_PAINT

    public static final java.awt.Paint DEFAULT_OUTLINE_PAINT

  The default outline paint.

### DEFAULT_STROKE

    public static final java.awt.Stroke DEFAULT_STROKE

  The default stroke.

### DEFAULT_OUTLINE_STROKE

    public static final java.awt.Stroke DEFAULT_OUTLINE_STROKE

  The default outline stroke.

### DEFAULT_SHAPE

    public static final java.awt.Shape DEFAULT_SHAPE

  The default shape.

### DEFAULT_VALUE_LABEL_FONT

    public static final java.awt.Font DEFAULT_VALUE_LABEL_FONT

  The default value label font.

### DEFAULT_VALUE_LABEL_PAINT

    public static final java.awt.Paint DEFAULT_VALUE_LABEL_PAINT

  The default value label paint.

Constructor Detail

### AbstractRenderer

    public AbstractRenderer()

  Default constructor.

Method Detail

### getDrawingSupplier

    public abstract DrawingSupplier getDrawingSupplier()

  Returns the drawing supplier from the plot.

  Returns:
    The drawing supplier.

### getItemPaint

    public java.awt.Paint getItemPaint(int row,
                                       int column)

  Returns the paint used to fill data items as they are drawn.

  The default implementation passes control to the `getSeriesPaint` method. You can override this method if you require different behaviour.

  Parameters:
    `row` - the row (or series) index (zero-based).
    `column` - the column (or category) index (zero-based).
  Returns:
    The paint (never `null`).

### getSeriesPaint

    public java.awt.Paint getSeriesPaint(int series)

  Returns the paint used to fill an item drawn by the renderer.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The paint (never `null`).

### setPaint

    public void setPaint(java.awt.Paint paint)

  Sets the paint to be used for ALL series, and sends a `RendererChangeEvent` to all registered listeners. If this is `null`, the renderer will use the paint for the series.

  Parameters:
    `paint` - the paint (`null` permitted).

### setPaint

    public void setPaint(java.awt.Paint paint,
                         boolean notify)

  Sets the paint to be used for all series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` permitted).
    `notify` - notify listeners?

### setSeriesPaint

    public void setSeriesPaint(int series,
                               java.awt.Paint paint)

  Sets the paint used for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `paint` - the paint (`null` permitted).

### setSeriesPaint

    public void setSeriesPaint(int series,
                               java.awt.Paint paint,
                               boolean notify)

  Sets the paint used for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index.
    `paint` - the paint (`null` permitted).
    `notify` - notify listeners?

### getBasePaint

    public java.awt.Paint getBasePaint()

  Returns the base paint.

  Returns:
    The base paint (never `null`).

### setBasePaint

    public void setBasePaint(java.awt.Paint paint)

  Sets the base paint and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).

### setBasePaint

    public void setBasePaint(java.awt.Paint paint,
                             boolean notify)

  Sets the base paint and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).
    `notify` - notify listeners?

### getItemOutlinePaint

    public java.awt.Paint getItemOutlinePaint(int row,
                                              int column)

  Returns the paint used to outline data items as they are drawn.

  The default implementation passes control to the getSeriesOutlinePaint method. You can override this method if you require different behaviour.

  Parameters:
    `row` - the row (or series) index (zero-based).
    `column` - the column (or category) index (zero-based).
  Returns:
    The paint (never `null`).

### getSeriesOutlinePaint

    public java.awt.Paint getSeriesOutlinePaint(int series)

  Returns the paint used to outline an item drawn by the renderer.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The paint (never `null`).

### setSeriesOutlinePaint

    public void setSeriesOutlinePaint(int series,
                                      java.awt.Paint paint)

  Sets the paint used for a series outline and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `paint` - the paint (`null` permitted).

### setSeriesOutlinePaint

    public void setSeriesOutlinePaint(int series,
                                      java.awt.Paint paint,
                                      boolean notify)

  Sets the paint used to draw the outline for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `paint` - the paint (`null` permitted).
    `notify` - notify listeners?

### setOutlinePaint

    public void setOutlinePaint(java.awt.Paint paint)

  Sets the outline paint for ALL series (optional).

  Parameters:
    `paint` - the paint (`null` permitted).

### setOutlinePaint

    public void setOutlinePaint(java.awt.Paint paint,
                                boolean notify)

  Sets the outline paint for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` permitted).
    `notify` - notify listeners?

### getBaseOutlinePaint

    public java.awt.Paint getBaseOutlinePaint()

  Returns the base outline paint.

  Returns:
    The paint (never `null`).

### setBaseOutlinePaint

    public void setBaseOutlinePaint(java.awt.Paint paint)

  Sets the base outline paint and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).

### setBaseOutlinePaint

    public void setBaseOutlinePaint(java.awt.Paint paint,
                                    boolean notify)

  Sets the base outline paint and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).
    `notify` - notify listeners?

### getItemStroke

    public java.awt.Stroke getItemStroke(int row,
                                         int column)

  Returns the stroke used to draw data items.

  The default implementation passes control to the getSeriesStroke method. You can override this method if you require different behaviour.

  Parameters:
    `row` - the row (or series) index (zero-based).
    `column` - the column (or category) index (zero-based).
  Returns:
    The stroke (never `null`).

### getSeriesStroke

    public java.awt.Stroke getSeriesStroke(int series)

  Returns the stroke used to draw the items in a series.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The stroke (never `null`).

### setStroke

    public void setStroke(java.awt.Stroke stroke)

  Sets the stroke for ALL series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` permitted).

### setStroke

    public void setStroke(java.awt.Stroke stroke,
                          boolean notify)

  Sets the stroke for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` permitted).
    `notify` - notify listeners?

### setSeriesStroke

    public void setSeriesStroke(int series,
                                java.awt.Stroke stroke)

  Sets the stroke used for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `stroke` - the stroke (`null` permitted).

### setSeriesStroke

    public void setSeriesStroke(int series,
                                java.awt.Stroke stroke,
                                boolean notify)

  Sets the stroke for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `stroke` - the stroke (`null` permitted).
    `notify` - notify listeners?

### getBaseStroke

    public java.awt.Stroke getBaseStroke()

  Returns the base stroke.

  Returns:
    The base stroke (never `null`).

### setBaseStroke

    public void setBaseStroke(java.awt.Stroke stroke)

  Sets the base stroke.

  Parameters:
    `stroke` - the stroke (`null` not permitted).

### setBaseStroke

    public void setBaseStroke(java.awt.Stroke stroke,
                              boolean notify)

  Sets the base stroke and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` not permitted).
    `notify` - notify listeners?

### getItemOutlineStroke

    public java.awt.Stroke getItemOutlineStroke(int row,
                                                int column)

  Returns the stroke used to outline data items.

  The default implementation passes control to the getSeriesOutlineStroke method. You can override this method if you require different behaviour.

  Parameters:
    `row` - the row (or series) index (zero-based).
    `column` - the column (or category) index (zero-based).
  Returns:
    The stroke (never `null`).

### getSeriesOutlineStroke

    public java.awt.Stroke getSeriesOutlineStroke(int series)

  Returns the stroke used to outline the items in a series.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The stroke (never `null`).

### setOutlineStroke

    public void setOutlineStroke(java.awt.Stroke stroke)

  Sets the outline stroke for ALL series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` permitted).

### setOutlineStroke

    public void setOutlineStroke(java.awt.Stroke stroke,
                                 boolean notify)

  Sets the outline stroke for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` permitted).
    `notify` - notify listeners?

### setSeriesOutlineStroke

    public void setSeriesOutlineStroke(int series,
                                       java.awt.Stroke stroke)

  Sets the outline stroke used for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `stroke` - the stroke (`null` permitted).

### setSeriesOutlineStroke

    public void setSeriesOutlineStroke(int series,
                                       java.awt.Stroke stroke,
                                       boolean notify)

  Sets the outline stroke for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index.
    `stroke` - the stroke (`null` permitted).
    `notify` - notify listeners?

### getBaseOutlineStroke

    public java.awt.Stroke getBaseOutlineStroke()

  Returns the base outline stroke.

  Returns:
    The stroke (never `null`).

### setBaseOutlineStroke

    public void setBaseOutlineStroke(java.awt.Stroke stroke)

  Sets the base outline stroke and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` not permitted).

### setBaseOutlineStroke

    public void setBaseOutlineStroke(java.awt.Stroke stroke,
                                     boolean notify)

  Sets the base outline stroke and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` not permitted).
    `notify` - a flag that controls whether or not listeners are notified.

### getItemShape

    public java.awt.Shape getItemShape(int row,
                                       int column)

  Returns a shape used to represent a data item.

  The default implementation passes control to the getSeriesShape method. You can override this method if you require different behaviour.

  Parameters:
    `row` - the row (or series) index (zero-based).
    `column` - the column (or category) index (zero-based).
  Returns:
    The shape (never `null`).

### getSeriesShape

    public java.awt.Shape getSeriesShape(int series)

  Returns a shape used to represent the items in a series.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The shape (never `null`).

### setShape

    public void setShape(java.awt.Shape shape)

  Sets the shape for ALL series (optional) and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `shape` - the shape (`null` permitted).

### setShape

    public void setShape(java.awt.Shape shape,
                         boolean notify)

  Sets the shape for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `shape` - the shape (`null` permitted).
    `notify` - notify listeners?

### setSeriesShape

    public void setSeriesShape(int series,
                               java.awt.Shape shape)

  Sets the shape used for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `shape` - the shape (`null` permitted).

### setSeriesShape

    public void setSeriesShape(int series,
                               java.awt.Shape shape,
                               boolean notify)

  Sets the shape for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero based).
    `shape` - the shape (`null` permitted).
    `notify` - notify listeners?

### getBaseShape

    public java.awt.Shape getBaseShape()

  Returns the base shape.

  Returns:
    The shape (never `null`).

### setBaseShape

    public void setBaseShape(java.awt.Shape shape)

  Sets the base shape and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `shape` - the shape (`null` not permitted).

### setBaseShape

    public void setBaseShape(java.awt.Shape shape,
                             boolean notify)

  Sets the base shape and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `shape` - the shape (`null` not permitted).
    `notify` - notify listeners?

### createTransformedShape

    protected java.awt.Shape createTransformedShape(java.awt.Shape shape,
                                                    double translateX,
                                                    double translateY)

  Creates and returns a translated version of a shape.

  Parameters:
    `shape` - the base shape.
    `translateX` - the x translation.
    `translateY` - the y translation.
  Returns:
    The shape.

### isItemLabelVisible

    public boolean isItemLabelVisible(int row,
                                      int column)

  Returns `true` if an item label is visible, and `false` otherwise.

  Parameters:
    `row` - the row index (zero-based).
    `column` - the column index (zero-based).
  Returns:
    A boolean.

### isSeriesItemLabelsVisible

    public boolean isSeriesItemLabelsVisible(int series)

  Returns `true` if the item labels for a series are visible, and `false` otherwise.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    A boolean.

### setItemLabelsVisible

    public void setItemLabelsVisible(boolean visible)

  Sets the visibility of the item labels for ALL series.

  Parameters:
    `visible` - the flag.

### setItemLabelsVisible

    public void setItemLabelsVisible(java.lang.Boolean visible)

  Sets the visibility of the item labels for ALL series (optional).

  Parameters:
    `visible` - the flag (`null` permitted).

### setItemLabelsVisible

    public void setItemLabelsVisible(java.lang.Boolean visible,
                                     boolean notify)

  Sets the visibility of item labels for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `visible` - a flag that controls whether or not the item labels are visible (`null` permitted).
    `notify` - a flag that controls whether or not listeners are notified.

### setSeriesItemLabelsVisible

    public void setSeriesItemLabelsVisible(int series,
                                           boolean visible)

  Sets a flag that controls the visibility of the item labels for a series.

  Parameters:
    `series` - the series index (zero-based).
    `visible` - the flag.

### setSeriesItemLabelsVisible

    public void setSeriesItemLabelsVisible(int series,
                                           java.lang.Boolean visible)

  Sets the visibility of the item labels for a series.

  Parameters:
    `series` - the series index (zero-based).
    `visible` - the flag (`null` permitted).

### setSeriesItemLabelsVisible

    public void setSeriesItemLabelsVisible(int series,
                                           java.lang.Boolean visible,
                                           boolean notify)

  Sets the visibility of item labels for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `visible` - the visible flag.
    `notify` - a flag that controls whether or not listeners are notified.

### getBaseItemLabelsVisible

    public java.lang.Boolean getBaseItemLabelsVisible()

  Returns the base setting for item label visibility.

  Returns:
    A flag (possibly `null`).

### setBaseItemLabelsVisible

    public void setBaseItemLabelsVisible(boolean visible)

  Sets the base flag that controls whether or not item labels are visible.

  Parameters:
    `visible` - the flag.

### setBaseItemLabelsVisible

    public void setBaseItemLabelsVisible(java.lang.Boolean visible)

  Sets the base setting for item label visibility.

  Parameters:
    `visible` - the flag (`null` permitted).

### setBaseItemLabelsVisible

    public void setBaseItemLabelsVisible(java.lang.Boolean visible,
                                         boolean notify)

  Sets the base visibility for item labels and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `visible` - the visibility flag.
    `notify` - a flag that controls whether or not listeners are notified.

### getItemLabelFont

    public java.awt.Font getItemLabelFont(int row,
                                          int column)

  Returns the font for an item label.

  Parameters:
    `row` - the row index (zero-based).
    `column` - the column index (zero-based).
  Returns:
    The font (never `null`).

### getItemLabelFont

    public java.awt.Font getItemLabelFont()

  Returns the font used for all item labels. This may be `null`, in which case the per series font settings will apply.

  Returns:
    The font (possibly `null`).

### setItemLabelFont

    public void setItemLabelFont(java.awt.Font font)

  Sets the item label font for ALL series and sends a `RendererChangeEvent` to all registered listeners. You can set this to `null` if you prefer to set the font on a per series basis.

  Parameters:
    `font` - the font (`null` permitted).

### setItemLabelFont

    public void setItemLabelFont(java.awt.Font font,
                                 boolean notify)

  Sets the item label font for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `font` - the font (`null` permitted).
    `notify` - a flag that controls whether or not listeners are notified.

### getSeriesItemLabelFont

    public java.awt.Font getSeriesItemLabelFont(int series)

  Returns the font for all the item labels in a series.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The font (possibly `null`).

### setSeriesItemLabelFont

    public void setSeriesItemLabelFont(int series,
                                       java.awt.Font font)

  Sets the item label font for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `font` - the font (`null` permitted).

### setSeriesItemLabelFont

    public void setSeriesItemLabelFont(int series,
                                       java.awt.Font font,
                                       boolean notify)

  Sets the item label font for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero based).
    `font` - the font (`null` permitted).
    `notify` - a flag that controls whether or not listeners are notified.

### getBaseItemLabelFont

    public java.awt.Font getBaseItemLabelFont()

  Returns the base item label font (this is used when no other font setting is available).

  Returns:
    The font (`never` null).

### setBaseItemLabelFont

    public void setBaseItemLabelFont(java.awt.Font font)

  Sets the base item label font and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `font` - the font (`null` not permitted).

### setBaseItemLabelFont

    public void setBaseItemLabelFont(java.awt.Font font,
                                     boolean notify)

  Sets the base item label font and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `font` - the font (`null` not permitted).
    `notify` - a flag that controls whether or not listeners are notified.

### getItemLabelPaint

    public java.awt.Paint getItemLabelPaint(int row,
                                            int column)

  Returns the paint used to draw an item label.

  Parameters:
    `row` - the row index (zero based).
    `column` - the column index (zero based).
  Returns:
    The paint (never `null`).

### getItemLabelPaint

    public java.awt.Paint getItemLabelPaint()

  Returns the paint used for all item labels. This may be `null`, in which case the per series paint settings will apply.

  Returns:
    The paint (possibly `null`).

### setItemLabelPaint

    public void setItemLabelPaint(java.awt.Paint paint)

  Sets the item label paint for ALL series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` permitted).

### setItemLabelPaint

    public void setItemLabelPaint(java.awt.Paint paint,
                                  boolean notify)

  Sets the item label paint for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint.
    `notify` - a flag that controls whether or not listeners are notified.

### getSeriesItemLabelPaint

    public java.awt.Paint getSeriesItemLabelPaint(int series)

  Returns the paint used to draw the item labels for a series.

  Parameters:
    `series` - the series index (zero based).
  Returns:
    The paint (possibly `null`).``

### setSeriesItemLabelPaint

    public void setSeriesItemLabelPaint(int series,
                                        java.awt.Paint paint)

  Sets the item label paint for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series (zero based index).
    `paint` - the paint (`null` permitted).

### setSeriesItemLabelPaint

    public void setSeriesItemLabelPaint(int series,
                                        java.awt.Paint paint,
                                        boolean notify)

  Sets the item label paint for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero based).
    `paint` - the paint (`null` permitted).
    `notify` - a flag that controls whether or not listeners are notified.

### getBaseItemLabelPaint

    public java.awt.Paint getBaseItemLabelPaint()

  Returns the base item label paint.

  Returns:
    The paint (never `null`).``

### setBaseItemLabelPaint

    public void setBaseItemLabelPaint(java.awt.Paint paint)

  Sets the base item label paint and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).

### setBaseItemLabelPaint

    public void setBaseItemLabelPaint(java.awt.Paint paint,
                                      boolean notify)

  Sets the base item label paint and, if requested, sends a `RendererChangeEvent` to all registered listeners..

  Parameters:
    `paint` - the paint (`null` not permitted).
    `notify` - a flag that controls whether or not listeners are notified.

### getPositiveItemLabelPosition

    public ItemLabelPosition getPositiveItemLabelPosition(int row,
                                                          int column)

  Returns the item label position for positive values.

  Parameters:
    `row` - the row index (zero-based).
    `column` - the column index (zero-based).
  Returns:
    The item label position (never `null`).

### getPositiveItemLabelPosition

    public ItemLabelPosition getPositiveItemLabelPosition()

  Returns the item label position for positive values in ALL series.

  Returns:
    The item label position (possibly `null`).

### setPositiveItemLabelPosition

    public void setPositiveItemLabelPosition(ItemLabelPosition position)

  Sets the item label position for positive values in ALL series, and sends a `RendererChangeEvent` to all registered listeners. You need to set this to `null` to expose the settings for individual series.

  Parameters:
    `position` - the position (`null` permitted).

### setPositiveItemLabelPosition

    public void setPositiveItemLabelPosition(ItemLabelPosition position,
                                             boolean notify)

  Sets the positive item label position for ALL series and (if requested) sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `position` - the position (`null` permitted).
    `notify` - notify registered listeners?

### getSeriesPositiveItemLabelPosition

    public ItemLabelPosition getSeriesPositiveItemLabelPosition(int series)

  Returns the item label position for all positive values in a series.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The item label position (never `null`).

### setSeriesPositiveItemLabelPosition

    public void setSeriesPositiveItemLabelPosition(int series,
                                                   ItemLabelPosition position)

  Sets the item label position for all positive values in a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `position` - the position (`null` permitted).

### setSeriesPositiveItemLabelPosition

    public void setSeriesPositiveItemLabelPosition(int series,
                                                   ItemLabelPosition position,
                                                   boolean notify)

  Sets the item label position for all positive values in a series and (if requested) sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `position` - the position (`null` permitted).
    `notify` - notify registered listeners?

### getBasePositiveItemLabelPosition

    public ItemLabelPosition getBasePositiveItemLabelPosition()

  Returns the base positive item label position.

  Returns:
    The position (never `null`).

### setBasePositiveItemLabelPosition

    public void setBasePositiveItemLabelPosition(ItemLabelPosition position)

  Sets the base positive item label position.

  Parameters:
    `position` - the position (`null` not permitted).

### setBasePositiveItemLabelPosition

    public void setBasePositiveItemLabelPosition(ItemLabelPosition position,
                                                 boolean notify)

  Sets the base positive item label position and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `position` - the position (`null` not permitted).
    `notify` - notify registered listeners?

### getNegativeItemLabelPosition

    public ItemLabelPosition getNegativeItemLabelPosition(int row,
                                                          int column)

  Returns the item label position for negative values. This method can be overridden to provide customisation of the item label position for individual data items.

  Parameters:
    `row` - the row index (zero-based).
    `column` - the column (zero-based).
  Returns:
    The item label position (never `null`).

### getNegativeItemLabelPosition

    public ItemLabelPosition getNegativeItemLabelPosition()

  Returns the item label position for negative values in ALL series.

  Returns:
    the item label position (possibly `null`).

### setNegativeItemLabelPosition

    public void setNegativeItemLabelPosition(ItemLabelPosition position)

  Sets the item label position for negative values in ALL series, and sends a `RendererChangeEvent` to all registered listeners. You need to set this to `null` to expose the settings for individual series.

  Parameters:
    `position` - the position (`null` permitted).

### setNegativeItemLabelPosition

    public void setNegativeItemLabelPosition(ItemLabelPosition position,
                                             boolean notify)

  Sets the item label position for negative values in ALL series and (if requested) sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `position` - the position (`null` permitted).
    `notify` - notify registered listeners?

### getSeriesNegativeItemLabelPosition

    public ItemLabelPosition getSeriesNegativeItemLabelPosition(int series)

  Returns the item label position for all negative values in a series.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The item label position (never `null`).

### setSeriesNegativeItemLabelPosition

    public void setSeriesNegativeItemLabelPosition(int series,
                                                   ItemLabelPosition position)

  Sets the item label position for negative values in a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `position` - the position (`null` permitted).

### setSeriesNegativeItemLabelPosition

    public void setSeriesNegativeItemLabelPosition(int series,
                                                   ItemLabelPosition position,
                                                   boolean notify)

  Sets the item label position for negative values in a series and (if requested) sends a. `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `position` - the position (`null` permitted).
    `notify` - notify registered listeners?

### getBaseNegativeItemLabelPosition

    public ItemLabelPosition getBaseNegativeItemLabelPosition()

  Returns the base item label position for negative values.

  Returns:
    The position (never `null`).

### setBaseNegativeItemLabelPosition

    public void setBaseNegativeItemLabelPosition(ItemLabelPosition position)

  Sets the base item label position for negative values and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `position` - the position (`null` not permitted).

### setBaseNegativeItemLabelPosition

    public void setBaseNegativeItemLabelPosition(ItemLabelPosition position,
                                                 boolean notify)

  Sets the base negative item label position and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `position` - the position (`null` not permitted).
    `notify` - notify registered listeners?

### getItemLabelAnchorOffset

    public double getItemLabelAnchorOffset()

  Returns the item label anchor offset.

  Returns:
    the offset.

### setItemLabelAnchorOffset

    public void setItemLabelAnchorOffset(double offset)

  Sets the item label anchor offset.

  Parameters:
    `offset` - the offset.

### calculateLabelAnchorPoint

    protected java.awt.geom.Point2D calculateLabelAnchorPoint(ItemLabelAnchor anchor,
                                                              double x,
                                                              double y,
                                                              PlotOrientation orientation)

  Calculates the item label anchor point.

  Parameters:
    `anchor` - the anchor.
    `x` - the x coordinate.
    `y` - the y coordinate.
    `orientation` - the plot orientation.
  Returns:
    the anchor point (never `null`).

### addChangeListener

    public void addChangeListener(RendererChangeListener listener)

  Registers an object to receive notification of changes to the renderer.

  Parameters:
    `listener` - the listener (`null` not permitted).

### removeChangeListener

    public void removeChangeListener(RendererChangeListener listener)

  Deregisters an object so that it no longer receives notification of changes to the renderer.

  Parameters:
    `listener` - the object (`null` not permitted).

### notifyListeners

    public void notifyListeners(RendererChangeEvent event)

  Notifies all registered listeners that the renderer has been modified.

  Parameters:
    `event` - information about the change event.

### equals

    public boolean equals(java.lang.Object obj)

  Tests this renderer for equality with another object.

  Parameters:
    `obj` - the object.
  Returns:
    `true` or `false`.

### hashCode

    public int hashCode()

  Returns a hashcode for the renderer.

  Returns:
    The hashcode.

### clone

    protected java.lang.Object clone()
                              throws java.lang.CloneNotSupportedException

  Returns an independent copy of the renderer.

  Returns:
    A clone.
  Throws:
    `java.lang.CloneNotSupportedException` - if some component of the renderer does not support cloning.

### getItemLabelAnchor

    public ItemLabelAnchor getItemLabelAnchor(int row,
                                              int column)

  Deprecated. Use getPositiveItemLabelPosition() or getNegativeItemLabelPosition().

  Returns the item label anchor.

  Parameters:
    `row` - the row.
    `column` - the column.
  Returns:
    The item label anchor.

### getSeriesItemLabelAnchor

    public ItemLabelAnchor getSeriesItemLabelAnchor(int series)

  Deprecated. Use getSeriesPositiveItemLabelPosition() or getSeriesNegativeItemLabelPosition().

  Returns the item label anchor for all labels in a series.

  Parameters:
    `series` - the series.
  Returns:
    The anchor point.

### setItemLabelAnchor

    public void setItemLabelAnchor(ItemLabelAnchor anchor)

  Deprecated. Use setPositiveItemLabelPosition()/setNegativeItemLabelPosition().

  Sets the item label anchor.

  Parameters:
    `anchor` - the anchor.

### setSeriesItemLabelAnchor

    public void setSeriesItemLabelAnchor(int series,
                                         ItemLabelAnchor anchor)

  Deprecated. Use setSeriesPositiveItemLabelPosition()/setSeriesNegativeItemLabelPosition().

  Sets the series item label anchor.

  Parameters:
    `series` - the series.
    `anchor` - the anchor.

### getBaseItemLabelAnchor

    public ItemLabelAnchor getBaseItemLabelAnchor()

  Deprecated. Use getBasePositiveItemLabelPosition()/getBaseNegativeItemLabelPosition().

  Returns the base item label anchor.

  Returns:
    The anchor point.

### setBaseItemLabelAnchor

    public void setBaseItemLabelAnchor(ItemLabelAnchor anchor)

  Deprecated. Use setBasePositiveItemLabelPosition()/setBaseNegativeItemLabelPosition().

  Sets the base item label anchor.

  Parameters:
    `anchor` - the anchor.

### getItemLabelTextAnchor

    public org.jfree.ui.TextAnchor getItemLabelTextAnchor(int row,
                                                          int column)

  Deprecated. Use getPositiveItemLabelPosition()/getNegativeItemLabelPosition().

  Returns the text anchor for an item label. This is a point relative to the label that will be aligned with another anchor point that is relative to the data item.

  Parameters:
    `row` - the row.
    `column` - the column.
  Returns:
    The text anchor.

### getSeriesItemLabelTextAnchor

    public org.jfree.ui.TextAnchor getSeriesItemLabelTextAnchor(int series)

  Deprecated. Use getSeriesPositiveItemLabelPosition()/getSeriesNegativeItemLabelPosition().

  Returns the text anchor for all item labels in a series.

  Parameters:
    `series` - the series.
  Returns:
    The text anchor.

### setItemLabelTextAnchor

    public void setItemLabelTextAnchor(org.jfree.ui.TextAnchor anchor)

  Deprecated. Use setPositiveItemLabelPosition()/setNegativeItemLabelPosition().

  Sets the item label text anchor for ALL series (optional).

  Parameters:
    `anchor` - the anchor (`null` permitted).

### setSeriesItemLabelTextAnchor

    public void setSeriesItemLabelTextAnchor(int series,
                                             org.jfree.ui.TextAnchor anchor)

  Deprecated. Use setSeriesPositiveItemLabelPosition()/setSeriesNegativeItemLabelPosition().

  Sets the item label text anchor for a series.

  Parameters:
    `series` - the series.
    `anchor` - the anchor.

### getBaseItemLabelTextAnchor

    public org.jfree.ui.TextAnchor getBaseItemLabelTextAnchor()

  Deprecated. Use getBasePositiveItemLabelPosition()/getBaseNegativeItemLabelPosition().

  Returns the base item label text anchor.

  Returns:
    The text anchor.

### setBaseItemLabelTextAnchor

    public void setBaseItemLabelTextAnchor(org.jfree.ui.TextAnchor anchor)

  Deprecated. Use setBasePositiveItemLabelPosition()/setBaseNegativeItemLabelPosition().

  Sets the default item label text anchor.

  Parameters:
    `anchor` - the anchor.

### getItemLabelRotationAnchor

    public org.jfree.ui.TextAnchor getItemLabelRotationAnchor(int row,
                                                              int column)

  Deprecated. Use getPositiveItemLabelPosition()/getNegativeItemLabelPosition().

  Returns the rotation anchor for an item label.

  Parameters:
    `row` - the row.
    `column` - the column.
  Returns:
    The rotation anchor.

### getSeriesItemLabelRotationAnchor

    public org.jfree.ui.TextAnchor getSeriesItemLabelRotationAnchor(int series)

  Deprecated. Use getSeriesPositiveItemLabelPosition()/getSeriesNegativeItemLabelPosition().

  Returns the rotation anchor for all item labels in a series.

  Parameters:
    `series` - the series.
  Returns:
    The rotation anchor.

### setItemLabelRotationAnchor

    public void setItemLabelRotationAnchor(org.jfree.ui.TextAnchor anchor)

  Deprecated. Use setPositiveItemLabelPosition()/setNegativeItemLabelPosition().

  Sets the rotation anchor for the item labels in ALL series.

  Parameters:
    `anchor` - the anchor (`null` permitted).

### setSeriesItemLabelRotationAnchor

    public void setSeriesItemLabelRotationAnchor(int series,
                                                 org.jfree.ui.TextAnchor anchor)

  Deprecated. Use setSeriesPositiveItemLabelPosition()/setSeriesNegativeItemLabelPosition().

  Sets the item label rotation anchor point for a series.

  Parameters:
    `series` - the series.
    `anchor` - the anchor point.

### getBaseItemLabelRotationAnchor

    public org.jfree.ui.TextAnchor getBaseItemLabelRotationAnchor()

  Deprecated. Use getBasePositiveItemLabelPosition()/getBaseNegativeItemLabelPosition().

  Returns the base item label rotation anchor point.

  Returns:
    The anchor point.

### setBaseItemLabelRotationAnchor

    public void setBaseItemLabelRotationAnchor(org.jfree.ui.TextAnchor anchor)

  Deprecated. Use setBasePositiveItemLabelPosition()/setBaseNegativeItemLabelPosition().

  Sets the base item label rotation anchor point.

  Parameters:
    `anchor` - the anchor point.

### getItemLabelAngle

    public java.lang.Number getItemLabelAngle(int row,
                                              int column)

  Deprecated. Use getPositiveItemLabelPosition()/getNegativeItemLabelPosition().

  Returns the angle for an item label.

  Parameters:
    `row` - the row.
    `column` - the column.
  Returns:
    The angle (in radians).

### getSeriesItemLabelAngle

    public java.lang.Number getSeriesItemLabelAngle(int series)

  Deprecated. Use getSeriesPositiveItemLabelPosition()/getSeriesNegativeItemLabelPosition().

  Returns the angle for all the item labels in a series.

  Parameters:
    `series` - the series.
  Returns:
    The angle (in radians).

### setItemLabelAngle

    public void setItemLabelAngle(java.lang.Number angle)

  Deprecated. Use setPositiveItemLabelPosition()/setNegativeItemLabelPosition().

  Sets the angle for the item labels in ALL series (optional).

  Parameters:
    `angle` - the angle (`null` permitted).

### setSeriesAngle

    public void setSeriesAngle(int series,
                               java.lang.Number angle)

  Deprecated. Use setSeriesPositiveItemLabelPosition()/setSeriesNegativeItemLabelPosition().

  Sets the angle for all item labels in a series.

  Parameters:
    `series` - the series.
    `angle` - the angle.

### getBaseItemLabelAngle

    public java.lang.Number getBaseItemLabelAngle()

  Deprecated. Use getBasePositiveItemLabelPosition()/getBaseNegativeItemLabelPosition().

  Returns the base item label angle.

  Returns:
    The angle.

### setBaseAngle

    public void setBaseAngle(java.lang.Number angle)

  Deprecated. Use setBasePositiveItemLabelPosition()/setBaseNegativeItemLabelPosition().

  Sets the base item label angle.

  Parameters:
    `angle` - the angle.